# Generated by sila2.code_generator; sila2.__version__: 0.9.2
from __future__ import annotations

from abc import ABC
from queue import Queue
from typing import TYPE_CHECKING, Optional, Union

from sila2.server import FeatureImplementationBase, MetadataDict

if TYPE_CHECKING:
    from ...server import Server


class DissolvedOxygenControllerBase(FeatureImplementationBase, ABC):
    parent_server: Server

    _DissolvedOxygen_producer_queue: Queue[Union[float, Exception]]
    _DissolvedOxygen_current_value: float

    def __init__(self, parent_server: Server):
        """

        Controlling the dissolved oxygen in a reactor.

        """
        super().__init__(parent_server=parent_server)

        self._DissolvedOxygen_producer_queue = Queue()

    def update_DissolvedOxygen(self, DissolvedOxygen: float, queue: Optional[Queue[float]] = None) -> None:
        """
        Current Dissolved Oxygen

        This method updates the observable property 'DissolvedOxygen'.

        :param queue: The queue to send updates to. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._DissolvedOxygen_producer_queue
            self._DissolvedOxygen_current_value = DissolvedOxygen
        queue.put(DissolvedOxygen)

    def DissolvedOxygen_on_subscription(self, *, metadata: MetadataDict) -> Optional[Queue[float]]:
        """
        Current Dissolved Oxygen

        This method is called when a client subscribes to the observable property 'DissolvedOxygen'

        :param metadata: The SiLA Client Metadata attached to the call
        :return: Optional `Queue` that should be used for updating this property.
            If None, the default Queue will be used.
        """
        pass

    def abort_DissolvedOxygen_subscriptions(self, error: Exception, queue: Optional[Queue[float]] = None) -> None:
        """
        Current Dissolved Oxygen

        This method aborts subscriptions to the observable property 'DissolvedOxygen'.

        :param error: The Exception to be sent to the subscribing client.
            If it is no DefinedExecutionError or UndefinedExecutionError, it will be wrapped in an UndefinedExecutionError.
        :param queue: The queue to abort. If None, the default Queue will be used.
        """
        if queue is None:
            queue = self._DissolvedOxygen_producer_queue
        queue.put(error)

    @property
    def current_DissolvedOxygen(self) -> float:
        try:
            return self._DissolvedOxygen_current_value
        except AttributeError:
            raise AttributeError("Observable property DissolvedOxygen has never been set")
